Doomsday Engine - Bug #251

[Doom] Nightmare monsters sometimes not fast
2005-08-23 00:27 - shmacky

Status: Progressed Start date: 2005-08-23
Priority: High % Done: 50%
Assignee:

Category: Vanilla emulation

Target version: Vanilla / Gameplay

Description

In Nightmare mode it is just like Ultra Violence but
with fast respawning monsters. Sometimes when loading
nightmare from

1. 2 simultaneous loadings
2. Loading from a saved game

Not all monsters are set on fast after such circumstances.

Labels: Doom

Related issues:

Related to Feature #1604: Game rules (1p and MP) New
Related to Feature #1617: Scoped definitions and variables New 2013-10-21
History

#1 - 2005-10-29 14:53 - danij

Logged In: YES
user_id=849456

All monsters are not supposed to be set to fast with either
-fast or in nightmare mode.

It is only the Demon and the speed of projectiles which is
altered.

#2 - 2012-06-10 12:52 - danij

Retrogamer observed:

"I'm playing Ultimate doom in Nightmare difficulty with doomsday 1.9.8. Everything is fine except when i loaded a saved-game after a new game, |
see strange behavior from enemies for example the fireball of Imp and the moving of Pinky demon is on normal speed. Is this a bug? (same behavior
with doomsday 1.8.6)"

#3 - 2012-07-13 10:02 - danij

Requires re-testing as of build 560, this may now be fixed.

#4 - 2012-08-27 20:23 - danij

- labels: jDoom Gameplay --> Doom
- summary: Nightmare monsters sometimes not fast. --> [Doom] Nightmare monsters sometimes not fast.
- milestone: -->v1.8.5

#5 - 2013-10-22 14:41 - skyjake

- Tags set to Doom, Gameplay, SaveGame

- Subject changed from [Doom] Nightmare monsters sometimes not fast. to [Doom] Nightmare monsters sometimes not fast
- Category set to Vanilla emulation

- Status changed from New to In Progress

- Target version changed from 1.8.6 to 1.13

- % Done changed from 0 to 50
#6 - 2013-10-22 23:26 - danij

The underlying cause of this is that game rules are not handled correctly, neither serialized properly to saved games or restored upon ending a
network game.

#7 - 2013-10-22 23:33 - vermil

This is actually a carry over from Vanilla Doom.

http://doomwiki.org/wiki/Some_game_options_not_preserved_in_saved_games

#8 - 2013-10-22 23:54 - danij

Yep, its certainly not specific to our port.
#9 - 2013-10-25 13:49 - vermil
The Nightmare stuff not saved in save games, seems to be the same stuff that the BFG Edition is missing entirely.

The Nightmare stuff not saved in save games all comes from the same small block of code, that originally resided in game.c. This block of code
controls the speeds of the Imp, Cacodemon and Barron/Hell Knight missiles on all skill levels. It also set’s the speed of the Demon in nightmare skill.

Heretic also controls its missile speeds in with a block of code in game.c, but unlike Doom, it saved it to save games.

This is also the case in Dday; Dday Doom doesn't save this information in a save game, but Dday Heretic appears to. In Dday both these blocks of
code are next to each other.

Both these blocks also prevent modders from changing the speeds of the missiles included in these blocks of codes; they overrule all mobj definitons
including Dday's ded files.

#10 - 2013-10-25 13:56 - vermil

I'm wrote the above to suggest that Dday may actually already have the code largely ready to fix ths issue, in Heretic, and to point out another issue
that stems from the same code.

Also to remind of the BFG edition if yourselves do wish to rewrite that block of code because as mentioned it's not in that edition (I am assuming that
Dday will want to imitate the BFG editions small gameplay alterations).

#11 - 2013-10-25 15:29 - danij

Perhaps an integrated mechanism using DED 2.0 selectors and Game Rules?

Concept syntax:

Thing {
Id = SERGEANT;
Speed = 10;
}
GameRule "Fast" { # Selector
Thing mods "SERGEANT" ({
Speed = 20;

}
}

#12 - 2013-10-25 16:17 - skyjake

Monster behavior does fit very well into the game rules concept.

#13 - 2013-11-01 08:05 - skyjake
- Target version deleted (1.13)

Unscheduling for now, since preferably some form of game rules would be needed for a good fix.

#14 - 2016-07-05 23:55 - skyjake

- Status changed from In Progress to Progressed

#15 - 2017-04-03 15:08 - skyjake

- Target version set to Modding
http://doomwiki.org/wiki/Some_game_options_not_preserved_in_saved_games

#16 - 2019-11-29 22:58 - skyjake

- Target version changed from Modding to Vanilla/ Gameplay
